#version 430

in vec3 position;
in vec3 normal;

out vec3 worldPosition;
out vec3 worldNormal;
out vec3 directionToLight;
out vec3 directionToCamera;
out vec4 ShadowCoord;

uniform mat4 model;
uniform mat4 view;
uniform mat4 project;

uniform mat4 DepthBiasMVP;

uniform vec3 lightPosition;
uniform vec3 cameraPosition;

void main(void) {
	
	worldPosition = (model * vec4(position,1)).xyz;
	worldNormal = (model * vec4(normal,0)).xyz;

	directionToLight = (lightPosition - worldPosition).xyz;
	directionToCamera = normalize(cameraPosition - worldPosition.xyz);

	gl_Position = project * view * model * vec4(position, 1);

	ShadowCoord = DepthBiasMVP * vec4(position ,1);
}